%{
  #include "../common_file/any2tfb.h"
%}

%union{   /* type of yylval */
  int narg;   /* number of args */
  Symbol *sym; /* pointer to symbol */
}

/*
  mathematica$B$G$O(B
  $BBgJ8;z$+$i;O$^$k1Q?t;zNs(B->$BAH$_9~$_4X?t(Bor$BAH$_9~$_Dj?t$N62$l$"$j(B
  $B>.J8;z$+$i;O$^$k1Q?t;zNs(B->$B%f!<%6Dj5AJQ?t(Bor$B4X?t(B
*/

%start list    /* $B%G%U%)%k%H$G$O(B1$BHV>e$N5,B'$+$i;O$^$k$N$G$3$l$O$J$/$F$b$h$$(B */
%token<sym> NUMBER VAR STRING  
%token<sym> FUNCTION PREVIOUS CONST
%token<sym> MODULE  /* mymodule`f$B$N7A(B($B%P%C%/%/%)!<%H(B) */
%token RANGE  /* $BJQ498e$K=P8=(B:$BHO0O(B */
%token PARENS LIST OPE ASSIGN   /* $B>.3g8L$HCf3g8L$H1i;;;R$HBeF~(B */
%token ELEMENT
%token FUNCTIONELEMENT   /* $B$3$l$b;H$o$J$$!#!#!#(B */
%token HUTEIGEN /*$B;H$o$J$$$1$I6&DL%b%8%e!<%k$N$?$a$K$OI,MW(B  */
%type<sym> expr asgn
%type<narg> datalist index end

%right '='
%left EQ  
%left '+' '-'
%left '*' '/'
%left UNARYMINUS  UNARYPLUS /* $BC19`73CD(B  */
%right '^'
%%

/*
  $B9=J8LZ:n@.4X?t$O4pK\E*$K(Basir2tfb$B$N$H$-$K:n$C$?(Btreemake.c$B$NCf?H$HF1$8(B
  ($B%3%T!<$7$?$b$N$r;H$&(B)
*/

list:   /* nothing */
| list end
| list expr end {print_expr(); printend($3);}
| list asgn end {print_expr(); printend($3);}
| list error end {yyerrok;}
;

end: '\n' {$$=0;} /* $B2~9T$O%H!<%/%s$+$i30$7$?$N$G$3$C$A$K$J$k$3$H$O$J$$(B */
| ';' {$$=0;}   /* ;$B$7$+<0$N=*$o$j$OBLL\$K$7$?(B->tfb$B$G$b(B;$B$KJQ49(B */
;

expr: NUMBER {push($1); $$=$1;}      /* $B?t;z(B */
| VAR  {push($1); $$=$1;}            /* $BJQ?t(Bor$BAH$_9~$_Dj?t(Bor$BAH$_9~$_4X?t(B */
| STRING {push($1); $$=$1;}          /* $BJ8;zNs(B */
| PREVIOUS {push($1); $$=$1;}        /* $BA02s$NEz$((B */
| CONST {push($1); $$=$1;}
| VAR '[' datalist ']' {$1->type=FUNCTION;$$=makefunc($1,$3);}/* $B4X?t8F$S=P$7(B*/
| MODULE '[' datalist ']' {$$=makefunc($1,$3);} /*$B%b%8%e!<%k4X?t8F$S=P$7(B*/
| '(' expr ')'         {$$=kakko();}
| expr '+' expr        {$$=add();}
| expr '-' expr        {$$=sub();}
| expr '*' expr        {$$=mul();}    
| expr '/' expr        {$$=divide();}
| expr '^' expr        {$$=power();}
| expr EQ expr         {$$=make_eq();}  /*$BJ}Dx<0(B*/
| '-' expr   %prec UNARYMINUS {$$=unaryminus();}
| '+' expr   %prec UNARYPLUS {$$=unaryplus();}
| '{' datalist '}'  {$$=makelist($2);} /* list or matrix */ 
| VAR index {$1->type=ELEMENT; $$=make_element($1,$2);} /* $BMWAG<h$j=P$7(B */
;

index: '[' '[' datalist ']' ']' {$$=$3;}
;

asgn: VAR '=' expr  {$$=assignment($1);}   /* $BJQ?t$X$NBeF~(B */
| VAR index '=' expr {$1->type=ELEMENT; $$=element_assign($1,$2,$4);}/*$BMWAG$X$NBeF~(B*/
;

/* $B0z?t$d%j%9%H$J$I$G$N%G!<%?$N%j%9%H(B */
datalist:    {$$=0;}/* nothing */ 
| expr       {$$=1;}  
| datalist ','  expr  {$$=$1+1;} 
;
%%
/* end of grammer */


#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<setjmp.h>
#include<string.h>
char *progname;
int lineno=1;    /* for error message */
jmp_buf begin;
int skip(void);    /* $B%3%a%s%H$H$P$7!\<!$N%H!<%/%s(B */
int commentskip(void);
int searchconst(char *);    /* $BDj?t$N%F!<%V%k$r8+$FDj?t$+$I$&$+H=CG(B  */
int follow(int,int,int);    /* $BJ#?tJ8;z$G0UL#$r;}$D%H!<%/%s$N%A%'%C%/(B */
static unsigned int buffersize=0x100000; /* $B%P%C%U%!%5%$%:(B:default 1Mbyte:1048576$B7e(B $B:GBg$G(B4294967295$B7e(B */
short src=MATH; /* $B$I$N%=%U%H$+$i$NJQ49$+(B */

main(int argc,char *argv[])
{
  int i;
  for(i=1;i<argc;i++){
	if(strcmp("--buffersize",argv[i])==0)
	  buffersize=atoi(argv[i+1]);   /* default$BCM$NJQ99(B */
  }
  progname=argv[0];
  setjmp(begin);
  yyparse();
}


int yylex(void)
{
  int c;
  char *value; /*$B;CDjE*$K?t;zNs$dJQ?t$NL>A0$J$I$rF~$l$kNN0h(B*/
  char *p;
  value=(char *)malloc(buffersize);
  p=value;
 
  c=skip();     /* $B%3%a%s%H2~9T6uGr%?%V$O$H$P$7(B */
  if(c==EOF){
	free(value);
	return 0;
  }
  if(myisdigit(c)){     /* NUMBER */
	do{
	  *p++=c;
	  if(p>=value+buffersize-1){
		*p='\0';
		execerror("number too big , please use --buffersize option.",(char *)0);	  }
	}while((c=getchar())!=EOF && myisdigit(c));
	if(c!='.'){         /* $B>.?t$G$J$$(B */
	  *p='\0';
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(NUMBER,value);
	  free(value);
	  return NUMBER;
	}
	do{                 /* $B>.?tE@0J2<$N%3%T!<(B */
	  *p++=c;
	  if(p>=value+buffersize-1){
		*p='\0';
		execerror("number too big , please use --buffersize option.",(char *)0);	  }
	}while((c=getchar())!=EOF && myisdigit(c));
	*p='\0';
	ungetc(c,stdin);
	yylval.sym=makesymbol(NUMBER,value);
	free(value);
	return NUMBER;
  }
  if(myisalpha(c)){  /* $B%"%k%U%!%Y%C%H$G;O$^$k(B->$BJQ?t(Bor$BAH$_9~$_Dj?t(Bor$B4X?t(B */
	do{
	  *p++=c;
	  if(p>=value+buffersize-1){
		*p='\0';
		execerror("number too big , please use --buffersize option.",(char *)0);	  }
	}while((c=getchar())!=EOF && (myisalnum(c) || c=='_'));

	if(c=='`'){  /* $B%P%C%/%/%)!<%H(B:mymodule`f$B$N7A(B */
	  do{
		*p++=c;
		if(p>=value+buffersize-1){
		  *p='\0';
		  execerror("number too big , please use --buffersize option.",(char *)0);	
		}
	  }while((c=getchar())!=EOF && (myisalnum(c) || c=='_'));
	  ungetc(c,stdin);
	  *p='\0';
	  yylval.sym=makesymbol(MODULE,value);
	  free(value);
	  return MODULE;
	}

	*p='\0';
	ungetc(c,stdin);
	if(searchconst(value)==1){
	  yylval.sym=makesymbol(CONST,value);
	  free(value);
	  return CONST;
	}
	yylval.sym=makesymbol(VAR,value);
	free(value);
	return VAR;
  }
  if(c=='"'){       /* $BJ8;zNs(B */
	for(;(c=getchar())!='"';p++){
	  if(c=='\n' || c==EOF){
		execerror("missing quote","");
	  }
	  if(p>=value+buffersize-1){
		*p='\0';
		execerror("string too long , please use --buffersize option",value);
	  }
	  *p=c;
	}
	*p='\0';
	yylval.sym=makesymbol(STRING,value);
	free(value);
	return STRING;
  }
  if(c=='%'){    /* %$B$OD>A0$NEz$((B,%%$B$O(B2$B2sA0(B */
	*p++='%';       /* $BF~$l$H$$$F(B */
	if((c=getchar())=='%'){  
	  do{
		*p++=c;
	  }while((c=getchar())=='%');
	  *p='\0';
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(PREVIOUS,value);
	  free(value);
	  return PREVIOUS;
	}
	if(myisdigit(c)){
	  do{   /* %$B$N8e$K?t;z$,B3$1$PFCJL(B */
		*p++=c;            /* $BB3$+$J$1$l$P(B%$B$N$_$N%H!<%/%s(B */
	  }while((c=getchar())!=EOF && myisdigit(c));
	  *p='\0';
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(PREVIOUS,value);
	  free(value);
	  return PREVIOUS;       /* $BDj?t(B  */
	}
	else{    /* %$B$N$_(B */
	  *p='\0';
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(PREVIOUS,value);
	  free(value);
	  return PREVIOUS;
	}
  }
  /* if(c=='\n')         mathematica$B$G$O2~9T$O%H!<%/%s$N#1$D(B 
	 lineno++;     $B$J$s$F$3$H$9$k$H%;%s%90-$$$N$G$d$a$?(B.$B>C$7$?J}$,$h$$(B  */
  free(value);
  return c;    /* default */
}  


int yyerror(char *s) /* call from yyparse when syntax error exists */
{
  warning(s,(char *)0);
}


int warning(char *s,char *t)
{
  fprintf(stderr,"%s: %s",progname,s);
  if(t!=0)
	fprintf(stderr,"%s",t);
  fprintf(stderr," near line %d\n",lineno);
}


void execerror(char *s,char *t)
{
  warning(s,t);
  longjmp(begin,0);
}


int skip()         /* Asir$B$H0c$C$F2~9T$OF~NO$N=*$j$r<($9$N$G(B\n$B$KCm0U(B  */
{
  int c;   
  int c1;   /* $B0lJ8;z@h$^$GFI$`$H$-(B */
  for((c=getchar()) ; ; ){
	switch(c){               
	case ' ': case '\t':  /* $B6uGr$OFI$_$H$P$7(B */
	  c=getchar(); 
	  break;
	case '\n':
	  lineno++;
	  c=getchar();
	  break;	  
	case '(':             /* ( $B$,$-$?(B->$B$5$i$K!v$,$-$?(B->$B%3%a%s%H(B */
	  if((c1=getchar())=='*')
		c=commentskip();    /* $B%3%a%s%H$rFI$_$H$P$7(B */
	  else{
		ungetc(c1,stdin);  /* ($B$N<!$,!v0J30(B-> ( $B$HH=Dj(B */
		return c;
	  }
	  break;
	case '=':  return follow('=',EQ,'=');
	default:
	  return c;
	  break;
	}
  }  
}


int commentskip()
{
  int c;
  int c1;
  for((c=getchar()); ; ){
	c1=getchar();    /* $B<!$NJ8;z$rFI$^$;$k(B */
	if((c=='*' && c1==')'))    /* '*'$B$H(B'/'$B$,O"B3$G$-$?(B->$B%3%a%s%H$N=*$j(B */
	  return getchar();       /* $B$5$i$K<!$NJ8;z$rJV$9(B  */
	else
	  c=c1;                    /* c$B$r(Bc1$B$KDI$$$D$+$;$k(B */
  }
}

#define A 10   /* $B8D?t(B */
int searchconst(char *value)    /* $BFI$_9~$s$@$b$N$,Dj?t$+$I$&$+$rAmEv$?$j$G%A%'%C%/$9$k(B */
{
  int i;
  char *const_table[A]={
	"I",
	"Infinity",
	"Pi",
	"Degree",
	"GoldenRatio",
	"E",
	"EulerGamma",
	"Catalan",
	NULL
  };
  for(i=0;const_table[i]!=NULL;i++){/* $B8!:w!'>/$J$$$7AmEv$?$j$G$b$$$$$G$7$g$&(B*/
	if(strcmp(value,const_table[i])==0)
	  return 1;
  }
  return 0;
}


int follow(int expect,int ifyes,int ifno)  /* look ahead for == etc.. */
{
  int c;
  c=getchar();
  if(c==expect)
	return ifyes;
  else{
	ungetc(c,stdin);
	return ifno;
  }
}
