/*  
	$B%b!<%IDj?t(B
	openmath,pmathml(presentation mathml)$B$O(B
    $B4X?t%F!<%V%k$J$I(Btarget$B$r;H$&4X?t$KBP1~$7$F$$$J$$$N$G(B
    define$B$9$kI,MW$b$J$$$,(B
	$B>-Mh$X$N4|BT$r9~$a$FDj5A$7$F$*$/(B
*/
#define NONE 10
#define ASIR 0
#define MATH 1
#define MAPLE 2
#define MATLAB 3
#define OPENMATH 4
#define PMATHML 5

extern short target;    /* $B$I$N%=%U%H$KJQ49$7$?$$$+(B */

typedef struct Symbol{
  short type;      /* NUMBER VAR HUTEIGEN STRING UNARYMINUS */
  short mode;      /* ASIR or MATH */
  char *value;    /* value or VAR name or FUNC name..  */
  int number;     /* number of children */
  struct Symbol **childp;  /* pointer to children */
}Symbol;



/*
  isdigit,isalnum$BEy$O(B-1$B$+$i(B255$B0J30$N?t;z$G$OF0$+$J$$$N$G:n@.(B
  (symbol.c)$B$K:n@.(B
*/
extern int myisdigit(int);   /*  number */
extern int myisupper(int);    /* upper */
extern int myislower(int);   /* lower */
extern int myisalnum(int);  /* alphabet or number */
extern int myisalpha(int);  /* alphabet */




/* $B0lHL4X?t(B(treemake.c, --.y,symbol.c) */
extern Symbol *makesymbol(short,short,char *);
extern void execerror(char *,char *);
extern void execerror2(char *,char *,char *);
extern void init(void);
extern void push(Symbol *);
extern Symbol *pop(void);

/* $BITDj85%j%9%H4X?t72(B(symbol.c):range$B$rBeF~$7$?ITDj85(B.   */
extern int lookup(char *);      /* $BITDj858!:w(B $B$"$C$?$i#1!"$J$+$C$?$i#0(B*/
extern void install(char *);    /* $B?7$?$JITDj85$N%j%9%H$X$NEPO?(B */
extern void var_remove(char *); /* $B%j%9%H$+$i$N:o=|(B&type$B$N(BHUTEIGEN$B$X$NJQ49(B */


/* range$BBeF~ITDj85%j%9%H4IM}4X?t72(B(symbol.c) */
extern Symbol *lookup_rangevar(char *);/*range$B858!:w(B,$BJV(B:$BA^F~%j%9%H(B,$BL5(B:NULL*/
extern void install_rangevar(char *,Symbol *);  /* range$BJQ?t$NEPO?(B */
extern void rangevar_remove(char *);   /*range$BJQ?t$N%j%9%H$+$i$N:o=|(B*/
extern int rangelist_number(void);     /*$BEPO?$5$l$F$$$k8D?t(B*/
extern char *rangevar_pickup(int);    /*$B%j%9%H$N(Bi$BHVL\$NL>A0$rJV$9(B.$B:G8e$O(BNULL*/


/* $B9=J8LZ:n@.4X?t72(B(treemake.c) */
extern void appendchildren1(Symbol *,int);    /* $B5U=g;R6!IU$1(B */
extern void appendchildren2(Symbol *,int);    /* $BAGD>$K;R6!IU$1(B */
extern Symbol *add(void);
extern Symbol *sub(void);
extern Symbol *mul(void);
extern Symbol *divide(void);
extern Symbol *power(void);
extern Symbol *mod(void);
extern Symbol *unaryplus(void);
extern Symbol *unaryminus(void);
extern Symbol *assignment(Symbol *);
extern Symbol *kakko(void);
extern Symbol *make_eq(void);
extern Symbol *makefunc(Symbol *,int);
extern Symbol *makefunc_elem(Symbol *,int,int);
extern Symbol *makelist(int);
extern Symbol *make_element(Symbol *,int);
extern Symbol *element_assign(Symbol *,int,Symbol *);
extern Symbol *func_elem_assign(Symbol *,int,int,Symbol *);

extern Symbol *makeset(int); 
extern Symbol *makerange(void); 
extern Symbol *makerangestep(void);
extern Symbol *make_duplicate_poly(int); /* $BJ,;6I=8=B?9`<0(B */

/* $B0J2<#2$D$O%F%9%H(B */
extern Symbol *makevector_or_matrix(int);
extern void makecolumn(void);


/* $B9=J8LZI=<(4X?t72(B(treeprint.c)  */
extern void print_expr(void);
extern void treeprint(Symbol *);
extern void printend(int);
extern void check_type(Symbol *,int,int);

/* $B9=J8LZJQ494X?t72(B(transform.c,table.c) */
extern void transform(Symbol *);  /* $BLZ$NAv::(B */
extern void functionchange(Symbol *);    /* $B4X?tL>$NJQ49(B */
extern char *function_searchtable(Symbol *);  /* $B4X?tJQ49%F!<%V%k$N8!:w(B */
extern void constchange(Symbol *);     /*$BDj?t$NJQ49(B  */
extern char *const_searchtable(Symbol *);  /* $BDj?tJQ49%F!<%V%k$N8!:w(B */

extern void insert(Symbol *,Symbol *);  /*$B?F$X$N;R$NA^F~(B($B:G8e$K(B)*/
extern void insert_into(Symbol* ,Symbol *,int);/*i$BHVL\$r$"$1$F;R6!$rA^F~(B*/
extern void insert_down(Symbol *,Symbol *,int);/*i$BHVA^F~(B.i$BHV$N;R$O$=$N;R6!$K(B*/
extern void insert_follow_down(Symbol *,Symbol *,int); /* $BA^F~$7$F0J2<$N;R$rA^F~%N!<%I$N;R$K$9$k(B*/

void swap(Symbol *,int,int);   /* i$BHV$H(Bj$BHV$N;R$rF~$l49$((B */


/*$BA^F~(B+$B85$N(Bi$BHV0J9_$r<h$j=|$-(B.$B$=$N;R$K$9$k(B */
extern void delete_up(Symbol *,int); /*n$BHVL\$N;R$N:o=|(B+$B$=$N;R$N;R$r2!$7>e$2(B*/
extern void delete(Symbol *,int); /* i$BHVL\$N;R$r;R$b4^$aA4:o=|(B*/
extern void delete_recursive(Symbol *); /* $B>e$+$i8F$S=P$5$l$k:F5":o=|4X?t(B */


#define CHILD 5    /* $BLZ9=B$$K$*$$$F=i4|>uBV$G;}$F$k;R6!$N?t(B */
