%{
  #include "../common_file/tfb2any.h"
  extern unsigned int buffersize;
  extern int omobj_flag;
  int omobj_flag=1;
%}

%union{   /* type of yylval */
  int narg;   /* number of args */
  Symbol *sym; /* pointer to symbol */
}

/*
  $B;n:nIJ(B:tfb($BCf4V8@8l(B)$B$O$[$\(BAsir$B$HF1$8J8K!!#(B
  $B4X?t$NA0$K$O$I$N%=%U%H$N4X?t$G$"$k$+$H$$$&0u$,$D$/!#(Basir@sin(X);
  $BJQ?t(B   $B%W%m%0%i%_%s%0$G$NJQ?t$N$3$H(B -> Risa/Asir$B$K$OBgJ8;z$GJQ49(B
  $BITDj85(B $BB?9`<0$NJQ?t$N$3$H(B  -> $B>.J8;z$N$^$^JQ49(B
  omobj_flag:tfb2openmath$B$@$1$NJQ?t(B.<OMOBJ></OMOBJ>$B$r=PNO$9$k$+$I$&$+$N%U%i%0(B
*/

/*
  $B6&DL%b%8%e!<%kMQ$K%H!<%/%s$rDj5A$7$F$$$k$@$1$G(B
  $B$[$H$s$I$O(Btfb2openmath$B$G$O;H$o$J$$(B
*/
%start list    /* $B%G%U%)%k%H$G$O(B1$BHV>e$N5,B'$+$i;O$^$k$N$G$3$l$O$J$/$F$b$h$$(B */
%token<sym> NUMBER VAR HUTEIGEN STRING/*HUTEIGEN:$BITDj85!J?t3X$G$NJQ?t(B)*/  
%token<sym> DEC /* decimal:$B>.?t(B */
%token <sym> PREVIOUS CONST /* VAR:$B%W%m%0%i%_%s%0$G$NJQ?t(B */
%token <sym> FUNCTION   /* $B%=%U%HL>(B@$B4X?tL>(B */
%token <sym> DOT_FUNC    /* hoge.b$B$N7A(B  */
%token VECTOR COLUMN     /* $BJQ49BP>]$K$J$k$+$OHyL/(B  */
%token ROW MATRIX /* $B9TNs$N9T(B,$B9TNs(B */
%token SET     /* $B=89g(B */
%token PARENS LIST OPE ASSIGN      /* $B>.3g8L$HBg3g8L$H1i;;;R$HBeF~1i;;;R(B */
%token ELEMENT            /* $BMWAGCj=P$N:]$NJQ?t(B  */
%token FUNCTIONELEMENT    /* $B4X?t8F$S=P$7$N$"$H$KMWAGHV9f$,$D$$$?>l9g(B */
%token DUMMYCOMMA   /* $B%@%_!<$N?F(B */
%token RANGE RANGEST  /* $BHO0O(B */
%type<sym> expr mfunc
%type<narg> datalist end


%right '='
%left EQ    /* ==$B$N$3$H!'J}Dx<0(B */
%left '+' '-'
%left '*' '/'
%left '%'   /* mod */
%left UNARYMINUS UNARYPLUS   /* $BC19`%^%$%J%9(B,$B%W%i%9(B */
%right '^'
%%

list:   /* nothing */
| list end
| list expr end    {print_expr(); printend($3);}
| list mfunc end {print_expr(); printend($3);}
| list error end   {yyerrok;}
;

end: ';' {$$=0; omobj_flag=1;}
| '$'    {$$=1; omobj_flag=0;}
;

/***************
NUMBER:$B?t;z(B
VAR:$BJQ?t(B
HUTEIGEN:$BITDj85(B
STRING:$BJ8;zNs(B
***************/

expr: NUMBER {push($1); $$=$1;} 
| DEC        {push($1); $$=$1;}
| VAR        {push($1); $$=$1;}
| HUTEIGEN   {push($1); $$=$1;}
| STRING     {push($1); $$=$1;} 
| FUNCTION '(' datalist ')' {$$=makefunc($1,$3);}  /* hoge@b */
| DOT_FUNC '(' datalist ')' {$$=makefunc($1,$3);}  /* hoge.b */
| '(' expr ')' {$$=kakko();}
| '(' mfunc ')' {$$=kakko();}
| expr '+' expr {$$=add();}
| expr '-' expr {$$=sub();}
| expr '*' expr {$$=mul();}
| expr '/' expr {$$=divide();}
| expr '^' expr {$$=power();}
| expr EQ expr  {$$=make_eq();}
| '[' datalist ']' {$$=makelist($2);}  /*$B%j%9%H(B->list1$B$N(Blist*/
| '-' expr   %prec UNARYMINUS {$$=unaryminus();} 
| '+' expr   %prec UNARYPLUS  {$$=unaryplus();}
;


mfunc: expr '~' DOT_FUNC '~' expr {$$=makefunc($3,2);}
| mfunc '~' DOT_FUNC '~' expr {$$=makefunc($3,2);}
;

/* $B0z?t$d%j%9%H$J$I$G$N%G!<%?$N%j%9%H(B */
datalist:  {$$=0;}  /* nothing */ 
| expr     {$$=1;}   
| mfunc {$$=1;}
| datalist ','  expr {$$=$1+1;} 
| datalist ',' mfunc {$$=$1+1;}
;
%%
/* end of grammer */


#include<stdio.h>
#include<ctype.h>
#include<setjmp.h>
#include<string.h>
extern int matrix_flag; /* $B9TNs:n@.%U%i%0(B */
extern int vector_flag; /* $B%j%9%H$r%Y%/%H%k$K$_$J$9%U%i%0(B */
char *progname;
int lineno=1;    /* for error message */
jmp_buf begin;
unsigned int buffersize=0x100000; /* $B%P%C%U%!%5%$%:(B:default 1Mbyte:1048576$B7e(B $B:GBg$G(B4294967295$B7e(B */
short target=OPENMATH;    /* $BJQ49$7$?$$?t3X%=%U%H(B */
int matrix_flag=0;
int vector_flag=0;

main(int argc,char *argv[])
{
  int i;
  for(i=1;i<argc;i++){
	if(strcmp("--buffersize",argv[i])==0)
	  buffersize=atoi(argv[i+1]);   /* default$BCM$NJQ99(B */
	if(strcmp(argv[i],"--matrix")==0)
	  matrix_flag=1;  /* $B9TNs2r<a%U%i%0(B  */
	if(strcmp(argv[i],"--vector")==0)
	  vector_flag=1;  /* ($B%j%9%H$r(B)$B%Y%/%H%k$H$7$F2r<a$r$9$k(B  */
  }
  progname=argv[0];
  setjmp(begin);
  yyparse();
}


int yyerror(char *s) /* call from yyparse when syntax error exists */
{
  warning(s,(char *)0);
}


int warning(char *s,char *t)
{
  fprintf(stderr,"%s: %s",progname,s);
  if(t!=0)
	fprintf(stderr,"%s",t);
  fprintf(stderr," near line %d\n",lineno);
}


void execerror(char *s,char *t)
{
  warning(s,t);
  init();
  longjmp(begin,0);
}


void execerror2(char *s,char *t,char *u)   /* $B%(%i!<%a%C%;!<%8$rA}$d$7$?$$(B */
{
  fprintf(stderr,"%s: %s" ,progname,s);
  if(t!=0)
	fprintf(stderr,"%s",t);
  if(u!=0)
	fprintf(stderr," %s",u);
  fprintf(stderr," near line %d\n",lineno);
  init();
  longjmp(begin,0);
}
